﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using FFTWSharp;
using System.Xml;
using System.Threading;


namespace KISS_Konsole
{
    public partial class Wisdom: Form
    {
        private TextBox textBox1;

        public Wisdom()
        {
            InitializeComponent();
            textBox1.AppendText("Wisdom will now calculate fastest FFT Routines for your system." + "\r\n");
            textBox1.AppendText("This will take several minutes, and this progress form will remain open" + "\r\n");
            textBox1.AppendText("until this process has completed.  Do NOT attempt to use the server until" + "\r\n");
            textBox1.AppendText("this process has completed and this progress form has closed." + "\r\n");
            textBox1.AppendText("\r\n");
    ThreadPool.QueueUserWorkItem(delegate //w3sz
            {
            IntPtr pin, pout, fplan1;
            int fftsize;
            int j;
            fftsize = 8192;
 
            for (j = 1; j < 8; j++)
            {
                // create two unmanaged arrays, properly aligned
                pin = fftwf.malloc(fftsize * 8);
                pout = fftwf.malloc(fftsize * 8);

                float[] fin, fout;

                fin = new float[fftsize * 2];
                fout = new float[fftsize * 2];

                int i;
                for (i = 0; i < fftsize / 2; i++)
                {
                    fin[2 * i] = (float)Math.Cos(i * Math.PI / 129.0);
                    fin[2 * i + 1] = (float)Math.Sin(i * Math.PI / 129.0);
                }
                Invoke((MethodInvoker)delegate
                {
                    textBox1.AppendText("Computing Wisdom Forward FFT for FFT size " + (fftsize).ToString() + "\r\n");
                });
              Console.WriteLine("Computing Wisdom forward for FFT size " + (fftsize).ToString());
                // create a plan
                fplan1 = fftwf.dft_1d(fftsize, pin, pout, fftw_direction.Forward, fftw_flags.Patient);

                Invoke((MethodInvoker)delegate
                {
                    textBox1.AppendText("Completed Wisdom Forward FFT for FFT size " + (fftsize).ToString() + "\r\n");
                });
               Console.WriteLine("Wisdom forward complete for FFT size " + (fftsize).ToString());
                Marshal.Copy(fin, 0, pin, fin.Length);
                fftwf.execute(fplan1);
                Marshal.Copy(pout, fout, 0, fout.Length);

                fftwf.export_wisdom(Form1.WisdomName);
                
                fftwf.free(pin);
                fftwf.free(pout);
                fftwf.destroy_plan(fplan1);
                fftsize = fftsize * 2;
            }
            Invoke((MethodInvoker)delegate
            {
                Form1.WisdomComplete = true;
                this.Close();
            });
            });
        }

        public void InitializeComponent()
        {
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(12, 12);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBox1.Size = new System.Drawing.Size(493, 479);
            this.textBox1.TabIndex = 0;
            // 
            // Form1
            // 
            this.ClientSize = new System.Drawing.Size(517, 503);
            this.Controls.Add(this.textBox1);
            this.Name = "Form1";
            this.ResumeLayout(false);
            this.PerformLayout();
            this.Show();
        }

    }
}
