﻿// Complex variable and FFT Routines by Chris Oakley
// Added by W3SZ

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KISS_Konsole
{
    public class complex
    {
        public float real = 0.0f;
        public float imag = 0.0f;
//Empty constructor
    public complex()
    {
    }
    public complex( float real, float im) 
    {
        this.real = real;
        this.imag = imag;
    }
    public string ToString()
    {
        string data = real.ToString() + " " + imag.ToString() + "i";
        return data;
    }
//Convert from polar to rectangular
    public static complex from_polar(double r, double radians)
    {
        complex data = new complex(Convert.ToSingle(r * Math.Cos(radians)), Convert.ToSingle(r * Math.Sin(radians)));
        return data;
    }
//Override addition operator
    public static complex operator +(complex a, complex b)
    {
        complex data = new complex(a. real + b.real , a. imag + b.imag );
        return data;
    }
//Override subtraction operator
    public static complex operator -(complex a, complex b)
    {
        complex data = new complex(a. real -b.real , a. imag -b.imag );
        return data;
    }
//Override multiplication operator
    public static complex operator *(complex a, complex b)
    {
        complex data = new complex((a. real * b.real ) -(a.imag * b.imag ), 
        (a. real * b.imag + (a.imag * b.real )));
        return data;
    }
//Return magnitude of complex number
    public float magnitude
    {
        get
    {
    return Convert.ToSingle(Math.Sqrt(Math.Pow(real, 2) + Math.Pow(imag, 2)));
    }
 }
    public float phase
    {
        get
    {
        return Convert.ToSingle(Math.Atan( imag / real));
    }
    }
  }
}

